Unit IA80R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, LE03R_p, UTIA10_p;

procedure IA80R(F :Func_F1; PHI :Func_F1; G :Func_F1; A :Real; B :Real;
                EPS :Real; N :Integer; M :Integer;
                var P :Array of Real; var Q :Array of Real;
                var RAB :Array of Real; var IERR :Integer);

implementation

procedure IA80R(F :Func_F1; PHI :Func_F1; G :Func_F1; A :Real; B :Real;
                EPS :Real; N :Integer; M :Integer;
                var P :Array of Real; var Q :Array of Real;
                var RAB :Array of Real; var IERR :Integer);
var
JKP1,ITNO,IB1,IB2,IB3,IB4,IB5,IB6,IB3P2,IB5P2,IDOK,I,IV,IJK4,IJK5,IJK,
   IC1,IC2,IJK1,IJKK,IJK3,K,KP1,KK,KD,KRET,NP1,NPM,MP1,J,II,
   IJK2 :Integer;
AEPS,ATEST,AXLB,DEL,H1,PZ,SGN,SUM,TEMPL,TEST,T1,T2,T3,T4,U,XLB,XXI,
   XXM1,Y,Y2,Y3,Z,ZZ,Z1,Z2,Z3,DK,DKP1,BB1 :Real;
const
SYS001 :Real = 3.1415926535897932384626433832795;
ONE :Real = 1.0;
ZERO :Real = 0.0;
HALF :Real = 0.5;
P01 :Real = 0.01;
P015 :Real = 0.015;
TEN :Real = 10.0;
P0625 :Real = 0.0625;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23,_24,_25,_26,_27,_28,_29,_30,_31,_32,_33,_34,_35,_36,
_37,_38,_39,_40,_41,_42,_43,_44,_45,_46,_47,_48,_49,_50,_51,_52,_53,
_54,_55,_56,_57,_58,_59;
begin
AEPS := 0.01*EPS;
XLB := ZERO;
AXLB := ONE;
ITNO := 1;
ATEST := ZERO;
NP1 := N+1;
NPM := N+M;
K := NPM+1;
KP1 := K+1;
MP1 := M+1;
DK := K;
DKP1 := DK+ONE;
IB1 := KP1;
IB2 := IB1+KP1;
IB3 := IB2+KP1;
IB4 := IB3+KP1;
IB5 := IB4+KP1;
IB6 := IB5+KP1;
IB3P2 := IB3+2;
IB5P2 := IB5+2;
IDOK := IB1+NP1;
for I:=1 to NP1 do
 begin
  P[I-1] := ZERO;
_1:
 end;
for I:=1 to MP1 do
 begin
  Q[I-1] := ZERO;
_2:
 end;
Q[0] := ONE;
XXI := ZERO;
KK := K div 2;
BB1 := (B-A)*HALF;
XXM1 := (B+A)*HALF;
if ( KK < 1 ) 
 then goto _4;
KD := IB4+1;
for I:=1 to KK do
 begin
  XXI := XXI+ONE;
  ZZ := Cos(SYS001*(ONE-XXI/DK))*BB1;
  IJK4 := KD+I;
  RAB[IJK4-1] := ZZ+XXM1;
  IJK4 := IB5-I;
  RAB[IJK4-1] := XXM1-ZZ;
_3:
 end;
_4:
RAB[IB4+0] := A;
RAB[IB5-1] := B;
_5:
for I:=1 to KP1 do
 begin
  IJK4 := IB4+I;
  IJK5 := IB5+I;
  RAB[IJK5-1] := PHI(RAB[IJK4-1]);
_6:
 end;
KRET := 1;
goto _10;
_7:
XLB := (RAB[IB2-1]+XLB*DK)/DKP1;
if ( M = 0 ) 
 then goto _18;
I := 1;
_8:
KRET := 2;
goto _10;
_9:
TEST := Abs(XLB-RAB[IB2-1]);
XLB := (RAB[IB2-1]+XLB*DK)/DKP1;
if ( TEST <= P01*Abs(XLB) ) or ( I >= 3 ) 
 then goto _16;
I := I+1;
goto _8;
_10:
KK := N+2;
SGN := ONE;
for IV:=1 to KP1 do
 begin
  SGN := -SGN;
  IJK := IB6+IV;
  RAB[IJK-1] := ONE;
  IJK5 := IB5+IV;
  TEST := RAB[IJK5-1];
  if ( N <= 0 ) 
   then goto _12;
  IC1 := IB6+IV;
  IC2 := (NP1-2)*KP1+IC1;
  J := IC1;
  while ( J<=IC2 ) do
   begin
    JKP1 := J+KP1;
    RAB[JKP1-1] := RAB[J-1]*TEST;
_11:
    inc(J,KP1);
   end;
_12:
  IJK1 := IB1+IV;
  IJK4 := IB4+IV;
  RAB[IJK1-1] := F(RAB[IJK4-1]);
  if ( M <= 0 ) 
   then goto _14;
  TEMPL := XLB*G(RAB[IJK4-1])*SGN-RAB[IJK1-1];
  IC1 := IB6+(KK-1)*KP1+IV;
  RAB[IC1-1] := TEST*TEMPL;
  if ( NPM < KK ) 
   then goto _14;
  IC2 := (NPM-KK)*KP1+IC1;
  J := IC1;
  while ( J<=IC2 ) do
   begin
    JKP1 := J+KP1;
    RAB[JKP1-1] := RAB[J-1]*TEST;
_13:
    inc(J,KP1);
   end;
_14:
  IC1 := IB6+KP1*(KP1-1)+IV;
  RAB[IC1-1] := SGN*G(RAB[IJK4-1]);
_15:
 end;
LE03R(RAB[IB6+0],1,KP1,KP1,RAB[IB1+0],0,RAB[0],
     IERR);
if ( IERR <> 0 ) 
 then goto _55;
case KRET of
 1: goto _7;
 2: goto _9;
end;
_16:
for I:=1 to M do
 begin
  IJK1 := IDOK+I;
  Q[I+0] := RAB[IJK1-1];
_17:
 end;
_18:
for I:=1 to NP1 do
 begin
  IJK1 := IB1+I;
  P[I-1] := RAB[IJK1-1];
_19:
 end;
U := ONE;
if ( XLB <> ZERO ) 
 then U := Sign(ONE,XLB);
Z1 := ZERO;
if ( K > 1 ) 
 then goto _20;
RAB[IB3+0] := P015*(RAB[IB4+1]-RAB[IB4+0]);
RAB[IB3+1] := -RAB[IB3+0];
goto _22;
_20:
for I:=2 to K do
 begin
  IJK3 := IB3+I;
  IJK4 := IB4+I+1;
  IJKK := IJK4-2;
  RAB[IJK3-1] := P015*(RAB[IJK4-1]-RAB[IJKK-1]);
_21:
 end;
RAB[IB3+0] := RAB[IB3+1]*HALF;
IJK3 := IB3+K;
RAB[IB4-1] := -RAB[IJK3-1]*HALF;
_22:
I := 1;
AXLB := ZERO;
_23:
IJK4 := IB4+I;
Y2 := RAB[IJK4-1];
IJK3 := IB3+I;
H1 := RAB[IJK3-1];
Y3 := Y2+H1;
PZ := Y2;
KRET := 1;
_24:
T1 := F(PZ);
T2 := PHI(PZ);
T3 := RAB[IDOK-1];
if ( N < 1 ) 
 then goto _26;
for II:=1 to N do
 begin
  IJK1 := IDOK-II;
  T3 := T3*T2+RAB[IJK1-1];
_25:
 end;
_26:
T4 := ZERO;
if ( M < 1 ) 
 then goto _28;
for II:=1 to M do
 begin
  IJK1 := IB2-II;
  T4 := (T4+RAB[IJK1-1])*T2;
_27:
 end;
_28:
T4 := T4+ONE;
T2 := T3/T4;
T3 := G(PZ);
T4 := Abs(T1/T3);
ATEST := EMax1(ATEST,T4);
DEL := (T2-T1)/T3;
case KRET of
 1: goto _29;
 2: goto _30;
 3: goto _34;
 4: goto _38;
 5: goto _43;
 6: goto _49;
end;
_29:
Z2 := DEL*U;
PZ := Y3;
KRET := 2;
goto _24;
_30:
Z3 := DEL*U;
if ( Z3 > Z2 ) 
 then goto _31;
H1 := -H1;
Z := Z3;
Z3 := Z2;
Z2 := Z;
Y := Y3;
Y3 := Y2;
Y2 := Y;
_31:
Y := Y3+H1;
if ( Y >= A ) 
 then goto _32;
Y := A;
goto _37;
_32:
if ( Y <= B ) 
 then goto _33;
Y := B;
goto _37;
_33:
PZ := Y;
KRET := 3;
goto _24;
_34:
Z := DEL*U;
if ( Z <= Z3 ) 
 then goto _35;
Y2 := Y3;
Y3 := Y;
Z2 := Z3;
Z3 := Z;
goto _31;
_35:
Y := -Z3-Z3+Z+Z2;
if ( Y = ZERO ) 
 then goto _36;
Y := (Y2+Y3)*HALF+H1*(Z2-Z3)/Y;
goto _37;
_36:
Y := Y3;
_37:
RAB[IJK4-1] := Y;
PZ := Y;
KRET := 4;
goto _24;
_38:
IJK2 := IB2+I;
RAB[IJK2-1] := DEL;
U := -U;
Z := Abs(DEL);
AXLB := EMax1(AXLB,Z);
if ( I = 1 ) 
 then goto _39;
if ( I = KP1 ) 
 then goto _39;
if ( RAB[IJK4-1] > RAB[IJK4-2] ) 
 then goto _39;
if ( Abs(AXLB) <= AEPS*ATEST ) 
 then goto _57;
IERR := 65;
_39:
if ( Z < TEN*ATEST ) 
 then goto _40;
IERR := 66;
goto _58;
_40:
Y := Abs(XLB);
Z2 := ONE;
if ( Y <> ZERO ) 
 then Z2 := Abs(Z-Y)/Y;
if ( Z1 < Z2 ) 
 then Z1 := Z2;
if ( I >= KP1 ) 
 then goto _41;
I := I+1;
goto _23;
_41:
IJK4 := IB4+1;
if ( RAB[IJK4-1] <= A ) 
 then goto _46;
H1 := (RAB[IJK4-1]-A)*P0625;
U := -ONE;
if ( XLB <> ZERO ) 
 then U := -Sign(ONE,XLB);
Z3 := ZERO;
Y := A;
I := 1;
_42:
PZ := Y;
KRET := 5;
goto _24;
_43:
Z := DEL*U;
if ( Z <= Z3 ) 
 then goto _44;
Z3 := Z;
Z2 := Y;
_44:
Y := Y+H1;
I := I+1;
if ( I <= 16 ) 
 then goto _42;
Z := Abs(XLB);
if ( Z3 <= Z ) 
 then goto _46;
for I:=2 to KP1 do
 begin
  IJK2 := IB3P2-I;
  RAB[IJK2-1] := RAB[IJK2-2];
  IJK4 := IB5P2-I;
  RAB[IJK4-1] := RAB[IJK4-2];
_45:
 end;
IJK4 := IB4+1;
RAB[IJK4-1] := Z2;
IJK2 := IB2+1;
RAB[IJK2-1] := Z3*U;
AXLB := EMax1(AXLB,Z3);
goto _52;
_46:
if ( RAB[IB5-1] > RAB[IB5-2] ) 
 then goto _47;
if ( Abs(AXLB) <= AEPS*ATEST ) 
 then goto _57;
IERR := 65;
goto _58;
_47:
if ( B <= RAB[IB5-1] ) 
 then goto _53;
H1 := P0625*(B-RAB[IB5-1]);
Z3 := ZERO;
Y := B;
U := -ONE;
if ( RAB[IB3-1] <> ZERO ) 
 then U := -Sign(ONE,RAB[IB3-1]);
I := 1;
_48:
PZ := Y;
KRET := 6;
goto _24;
_49:
Z := DEL*U;
if ( Z3 >= Z ) 
 then goto _50;
Z3 := Z;
Z2 := Y;
_50:
Y := Y-H1;
I := I+1;
if ( I <= 16 ) 
 then goto _48;
Z := Abs(XLB);
if ( Z >= Z3 ) 
 then goto _53;
for I:=1 to K do
 begin
  IJK2 := IB2+I;
  RAB[IJK2-1] := RAB[IJK2+0];
  IJK4 := IB4+I;
  RAB[IJK4-1] := RAB[IJK4+0];
_51:
 end;
RAB[IB5-1] := Z2;
RAB[IB3-1] := Z3*U;
AXLB := EMax1(AXLB,Z3);
_52:
XLB := -XLB;
Y := Z;
Z := ONE;
if ( Y <> ZERO ) 
 then Z := Abs(Z3-Y)/Y;
if ( Z1 < Z ) 
 then Z1 := Z;
_53:
if ( Z1 <= EPS ) 
 then goto _58;
if ( Abs(AXLB) <= AEPS*ATEST ) 
 then goto _57;
if ( ITNO >= 20 ) 
 then goto _56;
SUM := ZERO;
SGN := ONE;
for I:=1 to KP1 do
 begin
  IJK2 := IB2+I;
  SUM := SUM+SGN*RAB[IJK2-1];
  SGN := -SGN;
_54:
 end;
XLB := SUM/DKP1;
ITNO := ITNO+1;
goto _5;
_55:
IERR := 68;
goto _58;
_56:
IERR := 67;
goto _58;
_57:
IERR := 69;
_58:
RAB[0] := Sign(AXLB,XLB);
RAB[1] := AEPS;
if ( IERR = 0 ) 
 then goto _59;
UTIA10(IERR,80);
_59:
end;

end.
